﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Xml;

public class sequencer : MonoBehaviour
{
    public AudioSource audioSourceGood;
    public AudioSource audioSourceBad;
    public GameObject gameNote;
    public GameObject gameBoard;
    public GameObject scorep1;

    GameObject Player1;
    int sp1 = 0;
    GameObject Player2;

    public EdgeCollider2D p1lon;
    public EdgeCollider2D p1ron;
    public EdgeCollider2D p1loff;
    public EdgeCollider2D p1roff;


    int tempo = 0;
    int tpb = 0;

    bool p1_left=false;
    bool p1_right=false;

    bool p2_left = false;
    bool p2_right = false;

    string song = "bochveu_60bpm";


    struct Note
    {
        public float StartTime;
        public float EndTime;
        public int Value;
    }

    List<Note> _Notes;

    float distance = 17;
    struct click_Notes
    {
        public float note_length;
        public GameObject obj;
        public float StartTime;
        public float x;
    }
    
    List<click_Notes> goodlist;
    List<click_Notes> badlist;

    public static int NbPlayers = 1;

    void Start ()
    {

        audioSourceGood.clip = Resources.Load<AudioClip>(song);
        audioSourceBad.clip = Resources.Load<AudioClip>("shitty_" + song);

        goodlist = new List<click_Notes>();
        badlist = new List<click_Notes>();

        if (NbPlayers == 1)
        {
            parseXML("timestamp_" + song);
            generateNotes(goodlist, 0, Color.green);
            parseXML("timestamp_shitty_" + song);
            generateNotes(badlist, 0, Color.red);
            Player1 = Instantiate(gameBoard, new Vector3(0, 0, 0), Quaternion.identity);
        }

        
        audioSourceGood.Play();
        //audioSourceBad.Play();
    }

    void generateNotes(List<click_Notes> list, int p, Color c)
    {
        foreach (var i in _Notes)
        {
            click_Notes note;

            note.StartTime = i.StartTime;

            note.note_length = (i.EndTime - i.StartTime)/2;
            if (i.Value< 45)
                note.x = -3.5f + 2*p;
            else
                note.x = 3.5f + 2*p;

            note.obj = Instantiate(gameNote, new Vector3(note.x, (i.StartTime + note.note_length / 2) * distance - 7.15f, -1), Quaternion.identity);

            SpriteRenderer boop = note.obj.GetComponent<SpriteRenderer>();
            if (boop != null)
            {
                boop.size = new Vector2(1, note.note_length* distance);
            boop.color = c;
            }

            CapsuleCollider2D boopy = note.obj.GetComponent<CapsuleCollider2D>();
            if (boopy != null)
            {
                boopy.size = new Vector2(1, note.note_length* distance);
            }

            list.Add(note);
        }
    }


    // Update is called once per frame
    void Update ()
    {
        float time = audioSourceGood.time;

        if (audioSourceGood.isPlaying)
        {

            foreach (var note in goodlist)
            {
                note.obj.transform.position = new Vector3(note.x, (note.StartTime + note.note_length / 2 - audioSourceGood.time) * distance - 7.15f, -1);
            }

            foreach (var note in badlist)
            {
                note.obj.transform.position = new Vector3(note.x, (note.StartTime + note.note_length / 2 - audioSourceGood.time) * distance - 7.15f, -1);
            }


            if (Input.GetButtonDown("p1-left"))
            {
                p1_left = !p1_left;
            }
            if (Input.GetButtonDown("p1-right"))
            {
                p1_right = !p1_right;
            }

            if (Input.GetButtonDown("p2-left"))
            {
                p1_left = !p1_left;
            }
            if (Input.GetButtonDown("p2-right"))
            {
                p1_right = !p1_right;
            }

            if (p1_left)
            {

                foreach (var note in goodlist)
                {
                    if (p1lon.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {
                        sp1++;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();
                    }
                }

                foreach (var note in badlist)
                {
                    if (p1lon.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1--;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

            }
            if (!p1_left)
            {

                foreach (var note in goodlist)
                {
                    if (p1loff.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1--;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

                foreach (var note in badlist)
                {
                    if (p1loff.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1++;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

            }
            if (p1_right)
            {

                foreach (var note in goodlist)
                {
                    if (p1ron.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1++;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

                foreach (var note in badlist)
                {
                    if (p1ron.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1--;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

            }
            if (!p1_right)
            {

                foreach (var note in goodlist)
                {
                    if (p1roff.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1--;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

                foreach (var note in badlist)
                {
                    if (p1roff.IsTouching(note.obj.GetComponent<CapsuleCollider2D>()))
                    {

                        sp1++;
                        scorep1.GetComponent<UnityEngine.UI.Text>().text = sp1.ToString();

                    }
                }

            }
            if (p2_left)
            {

            }
            if (!p2_left)
            {

            }
            if (p2_right)
            {

            }
            if (!p2_right)
            {

            }

        }
    }

    void parseXML(string filename)
    {
        _Notes = new List<Note>();

        var asset = Resources.Load<TextAsset>(filename);

        if (asset != null)
        {
            XmlDocument xmlDoc = new XmlDocument(); // xmlDoc is the new xml document.
            xmlDoc.LoadXml(asset.text); // load the file.

            var midi_file = xmlDoc.GetElementsByTagName("MIDIFile");

            if (midi_file.Count == 1)
            {
                var el_list = midi_file[0].ChildNodes;
                foreach (XmlNode e in el_list)
                {
                    if (e.Name == "TicksPerBeat")
                    {
                        int.TryParse(e.InnerText, out tpb);
                        Debug.Log("TPB = " + tpb);
                    }
                    else if (e.Name == "Track")
                    {
                        if (e.Attributes["Number"].Value == "0")
                        {
                            var evt_list = e.ChildNodes;
                            foreach (XmlNode evt in evt_list)
                            {
                                var info_list = evt.ChildNodes;

                                foreach (XmlNode info in info_list)
                                {
                                    if (info.Name == "SetTempo") // Backup time
                                    {

                                        int.TryParse(info.Attributes["Value"].Value, out tempo);
                                        Debug.Log("tempo = " + tempo);
                                    }
                                }
                            }
                        }

                        if (e.Attributes["Number"].Value == "1")
                        {
                            var evt_list = e.ChildNodes;

                            float time = 0;
                            float note_start_time = 0;
                            int color = 0;

                            foreach (XmlNode evt in evt_list)
                            {
                                var info_list = evt.ChildNodes;

                                foreach (XmlNode info in info_list)
                                {
                                    if (info.Name == "Absolute") // Backup time
                                    {
                                        int t = 0;
                                        int.TryParse(info.InnerText, out t);

                                        time = (float)((((t / ((double)tpb)) * (((double)tempo)))/1000000)/2.0);
                                        Debug.Log("time = " + time);
                                    }
                                    else if (info.Name == "NoteOn")
                                    {
                                        int.TryParse(info.Attributes["Note"].Value, out color);

                                        if (info.Attributes["Velocity"].Value == "127") // Key down
                                        {
                                            note_start_time = time;
                                        }
                                        else if (info.Attributes["Velocity"].Value == "0") // key up
                                        {
                                            Note note = new Note();
                                            note.StartTime = note_start_time;
                                            note.EndTime = time;
                                            note.Value = color;

                                            _Notes.Add(note);

            }   }   }   }   }   }   }   }

            Debug.Log("BPM = " + 60000000.0 / ((double)tempo));

}   }   }
